/////////////////////////////////////////////////////////////////////////
#ifndef __CINT__
#include "RooGlobalFunc.h"
#endif
#include "RooRealVar.h"
#include "RooStats/SPlot.h"
#include "RooDataSet.h"
#include "RooRealVar.h"
#include "RooGaussian.h"
#include "RooExponential.h"
#include "RooChebychev.h"
#include "RooAddPdf.h"
#include "RooProdPdf.h"
#include "RooAddition.h"
#include "RooProduct.h"
#include "TCanvas.h"
#include "RooAbsPdf.h"
#include "RooFit.h"
#include "RooFitResult.h"
#include "RooWorkspace.h"
#include "RooConstVar.h"
#include "/home/jyzhang/Tools/test_RooPdf_forGPU/inc/RooTestPdf.hh"
using namespace RooFit ;

void fit(){
    gSystem->Load("libPhysics");
    R__LOAD_LIBRARY(/home/jyzhang/Tools/test_RooPdf_forGPU/lib/libRBW.so);
    // Creat instance of RooTestPdf
    RooRealVar Theta1("Theta1","Theta1",0.0,1.0);
    RooRealVar Theta2("Theta2","Theta2",0.0,1.0);
    RooRealVar a1("a1","a1",0.756,-10.0,10.0);
    RooRealVar a2("a2","a2",0.5,-10.0,10.0);
    a1.setConstant();
    // Construct virtual PDF
    RooTestPdf pdf("pdf","pdf",Theta1,Theta2,a1,a2,true,1);

    // Read toy phspMC
    pdf.readMC("./toy_phsp.dat", "sig", "");
    // Read toy data
    RooRealVar Weight("Weight","Weight", -2.0, 2.0);
    RooArgSet theSet(Theta1,Theta2,Weight);
    RooDataSet *data_temp = pdf.readData("./toy_data.dat", "sig", "", theSet);
    RooDataSet *data = new RooDataSet( data_temp->GetName(),
            data_temp->GetTitle(), 
            data_temp, *data_temp->get(), 0, Weight.GetName());
    data->convertToTreeStore();
//    RooFitResult *result = pdf.fitTo(*data, Save(kTRUE), BatchMode("CPU"));
    RooFitResult *result = pdf.fitTo(*data, Save(kTRUE), NumCPU(60), Timer(true));
    result->Print("v");
    return;
}
